<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Api\Data;

interface UnitEntityInterface
{
    public const ID = 'id';
    public const NAME = 'name';
    public const MEASURE_UNIT = 'measure_unit';
    public const REFERENCE_UNIT = 'reference_unit';
    public const REFERENCE_AMOUNT = 'reference_amount';
    public const CONVERSION_RATE = 'conversion_rate';
    public const TEXT_TEMPLATE = 'text_template';

    /**
     * @return string
     */
    public function getName(): string;

    /**
     * @param string $name
     *
     * @return void
     */
    public function setName(string $name): void;

    /**
     * @return string
     */
    public function getMeasureUnit(): string;

    /**
     * @param string $measureUnit
     *
     * @return void
     */
    public function setMeasureUnit(string $measureUnit): void;

    /**
     * @return string
     */
    public function getReferenceUnit(): string;

    /**
     * @param string $referenceUnit
     *
     * @return void
     */
    public function setReferenceUnit(string $referenceUnit): void;

    /**
     * @return float
     */
    public function getReferenceAmount(): float;

    /**
     * @param float $referenceAmount
     * @return void
     */
    public function setReferenceAmount(float $referenceAmount): void;

    /**
     * Rate to converse from measure_unit to reference_unit
     *
     * @return float
     */
    public function getConversionRate(): float;

    /**
     * @param float $conversionRate
     *
     * @return void
     */
    public function setConversionRate(float $conversionRate): void;

    /**
     * @return string
     */
    public function getTextTemplate(): string;

    /**
     * @param string $textTemplate
     *
     * @return void
     */
    public function setTextTemplate(string $textTemplate): void;
}
