<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model;

use Amasty\Base\Model\ConfigProviderAbstract;

class ConfigProvider extends ConfigProviderAbstract
{
    public const ENABLED = 'general/enable';

    /**
     * @var string
     */
    protected $pathPrefix = 'amasty_price_per_unit/';

    public function isEnabled(?int $storeId = null): bool
    {
        return $this->isSetFlag(self::ENABLED, $storeId);
    }
}
