<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model\ResourceModel;

use Amasty\PricePerUnit\Api\Data\UnitEntityInterface;
use Amasty\PricePerUnit\Model\Product\ClearAttributeData;
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Model\ResourceModel\Db\AbstractDb;
use Magento\Framework\Model\ResourceModel\Db\Context;

class UnitEntity extends AbstractDb
{
    public const TABLE_NAME = 'amasty_unit_entity';

    /**
     * @var ClearAttributeData
     */
    private ClearAttributeData $clearAttributeData;

    protected function _construct()
    {
        $this->_init(self::TABLE_NAME, UnitEntityInterface::ID);
    }

    public function __construct(
        Context $context,
        ClearAttributeData $clearAttributeData,
        $connectionName = null
    ) {
        parent::__construct($context, $connectionName);
        $this->clearAttributeData = $clearAttributeData;
    }

    protected function _afterDelete(AbstractModel $object): self
    {
        $this->clearAttributeData->execute((int)$object->getId());

        return parent::_afterDelete($object);
    }
}
