<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model\Source;

use Amasty\PricePerUnit\Api\Data\UnitEntityInterface;
use Magento\Eav\Model\Entity\Attribute\Source\AbstractSource;

class Unit extends AbstractSource
{
    /**
     * @var ColumnOptionsFactory
     */
    private ColumnOptionsFactory $optionsFactory;

    public function __construct(
        ColumnOptionsFactory $optionsFactory
    ) {
        $this->optionsFactory = $optionsFactory;
    }

    public function getAllOptions(): ?array
    {
        if ($this->_options === null) {
            /** @var ColumnOptions $optionsProvider */
            $optionsProvider = $this->optionsFactory->create(
                ['columnValue' => UnitEntityInterface::ID, 'columnLabel' => UnitEntityInterface::NAME]
            );
            $this->_options = $optionsProvider->toOptionArray();
            array_unshift($this->_options, ['value' => 0, 'label' => __('--Please Select--')]);
        }

        return $this->_options;
    }
}
