<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model;

class UnitCalculator
{
    public function calculate(UnitEntity $unit, float $productPrice, float $productAmount): float
    {
        $result = 0.0;
        if ($productAmount) {
            $result = bcdiv((string)$productPrice, (string)$productAmount, 10)
                * $unit->getConversionRate() * $unit->getReferenceAmount();
        }

        return $result;
    }
}
