<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model;

use Amasty\PricePerUnit\Api\Data\UnitEntityInterface;
use Amasty\PricePerUnit\Model\ResourceModel\UnitEntity as UnitEntityResource;
use Magento\Framework\Model\AbstractModel;

class UnitEntity extends AbstractModel implements UnitEntityInterface
{
    protected function _construct()
    {
        $this->_init(UnitEntityResource::class);
    }

    public function getId(): ?int
    {
        return ($this->_getData(self::ID) === null) ? null
            : (int)$this->_getData(self::ID);
    }

    public function getName(): string
    {
        return (string)$this->_getData(self::NAME);
    }

    public function setName(string $name): void
    {
        $this->setData(self::NAME, $name);
    }

    public function getMeasureUnit(): string
    {
        return (string)$this->_getData(self::MEASURE_UNIT);
    }

    public function setMeasureUnit(string $measureUnit): void
    {
        $this->setData(self::MEASURE_UNIT, $measureUnit);
    }

    public function getReferenceUnit(): string
    {
        return (string)$this->_getData(self::REFERENCE_UNIT);
    }

    public function setReferenceUnit(string $referenceUnit): void
    {
        $this->setData(self::REFERENCE_UNIT, $referenceUnit);
    }

    public function getConversionRate(): float
    {
        return (float)$this->_getData(self::CONVERSION_RATE);
    }

    public function setConversionRate(float $conversionRate): void
    {
        $this->setData(self::CONVERSION_RATE, $conversionRate);
    }

    public function getReferenceAmount(): float
    {
        return (float)$this->_getData(self::REFERENCE_AMOUNT);
    }

    public function setReferenceAmount(float $referenceAmount): void
    {
        $this->setData(self::REFERENCE_AMOUNT, $referenceAmount);
    }

    public function getTextTemplate(): string
    {
        return (string)$this->_getData(self::TEXT_TEMPLATE);
    }

    public function setTextTemplate(string $textTemplate): void
    {
        $this->setData(self::TEXT_TEMPLATE, $textTemplate);
    }
}
