<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model\UnitEntity;

use Amasty\PricePerUnit\Model\UnitEntity;

class Registry
{
    /**
     * @var UnitEntity[]
     */
    private array $unitEntities = [];

    public function get(int $key): ?UnitEntity
    {
        return $this->unitEntities[$key] ?? null;
    }

    public function set(int $key, UnitEntity $item): void
    {
        $this->unitEntities[$key] = $item;
    }

    public function unset(int $key): void
    {
        unset($this->unitEntities[$key]);
    }

    public function isset(int $key): bool
    {
        return isset($this->unitEntities[$key]);
    }
}
