<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Model\UnitEntity;

use Amasty\PricePerUnit\Model\ResourceModel\UnitEntity as ResourceUnitEntity;
use Amasty\PricePerUnit\Model\UnitEntity;
use Magento\Framework\Exception\CouldNotSaveException;

class Save
{
    /**
     * @var ResourceUnitEntity
     */
    private ResourceUnitEntity $resourceUnitEntity;

    public function __construct(
        ResourceUnitEntity $resourceUnitEntity
    ) {
        $this->resourceUnitEntity = $resourceUnitEntity;
    }

    public function execute(UnitEntity $unitEntity): void
    {
        try {
            $this->resourceUnitEntity->save($unitEntity);
        } catch (\Exception $exception) {
            throw new CouldNotSaveException(
                __(
                    'Could not save the Unit Entity: %1',
                    $exception->getMessage()
                )
            );
        }
    }
}
