<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Plugin\Catalog\Block\Product\ListProduct;

use Amasty\PricePerUnit\Model\ConfigProvider;
use Amasty\PricePerUnit\Model\Product\PreloadUnitEntities;
use Magento\Catalog\Block\Product\ListProduct;
use Magento\Catalog\Model\ResourceModel\Product\Collection;

class PreloadUnits
{
    /**
     * @var PreloadUnitEntities
     */
    private PreloadUnitEntities $preloadUnitEntities;

    /**
     * @var bool
     */
    private bool $isLoaded = false;

    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(
        PreloadUnitEntities $preloadUnitEntities,
        ConfigProvider $configProvider
    ) {
        $this->preloadUnitEntities = $preloadUnitEntities;
        $this->configProvider = $configProvider;
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetLoadedProductCollection(ListProduct $subject, Collection $result): Collection
    {
        if ($this->isLoaded || !$this->configProvider->isEnabled()) {
            return $result;
        }

        $this->preloadUnitEntities->execute($result);
        $this->isLoaded = true;

        return $result;
    }
}
