<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Plugin\Catalog\Ui\DataProvider\CatalogEavValidationRules;

use Amasty\PricePerUnit\Model\Product\AttributeData;
use Magento\Catalog\Api\Data\ProductAttributeInterface;
use Magento\Catalog\Ui\DataProvider\CatalogEavValidationRules;

class AddValidationRule
{
    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterBuild(
        CatalogEavValidationRules $subject,
        array $result,
        ProductAttributeInterface $attribute,
        array $data
    ): array {
        // Magento adds only certain rules.
        // See \Magento\Catalog\Ui\DataProvider\CatalogEavValidationRules::mapRules().
        if ($attribute->getAttributeCode() === AttributeData::AMOUNT_ATTRIBUTE) {
            $result['validate-greater-than-zero'] = true;
        }

        return $result;
    }
}
