<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Plugin\Framework\Pricing\Amount;

use Amasty\PricePerUnit\Block\UnitPrice;
use Magento\Framework\Pricing\Amount\AmountInterface;

class AddUnitAdjustment
{
    /**
     * Return 0 for adding price per unit adjustment render.
     *
     * Adjustment amount summed with final price.
     * Unit price should not be summed up.
     * Return not boolean false result as adjustment exists.
     * @see \Magento\Framework\Pricing\Render\Amount::getAdjustments
     *
     * @param AmountInterface $subject
     * @param float $result
     * @param string $adjustmentCode
     * @return float
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetAdjustmentAmount(AmountInterface $subject, float $result, $adjustmentCode): float
    {
        if ($adjustmentCode === UnitPrice::CODE) {
            return 0;
        }

        return $result;
    }
}
