<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Plugin\GroupedProduct\Model\Product\Type\Grouped;

use Amasty\PricePerUnit\Model\Product\AttributeData;
use Magento\Catalog\Model\Product;
use Magento\Catalog\Model\ResourceModel\Product\Link\Product\Collection;
use Magento\GroupedProduct\Model\Product\Type\Grouped as GroupedType;

class AddUnitAttributes
{
    /**
     * @param GroupedType $subject
     * @param Collection $result
     * @param Product $product
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetAssociatedProductCollection(GroupedType $subject, Collection $result, $product): Collection
    {
        $result->addAttributeToSelect([AttributeData::AMOUNT_ATTRIBUTE, AttributeData::MEASURING_UNIT_ATTRIBUTE]);
        return $result;
    }
}
