<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Plugin\Quote\Model\Quote\Config;

use Amasty\PricePerUnit\Model\ConfigProvider;
use Amasty\PricePerUnit\Model\Product\AttributeData;
use Magento\Quote\Model\Quote\Config;

class AddUnitAttributes
{
    /**
     * @var ConfigProvider
     */
    private ConfigProvider $configProvider;

    public function __construct(ConfigProvider $configProvider)
    {
        $this->configProvider = $configProvider;
    }

    /**
     * @param Config $subject
     * @param string[] $result
     * @return string[]
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetProductAttributes(Config $subject, array $result): array
    {
        if ($this->configProvider->isEnabled()) {
            $result[] = AttributeData::MEASURING_UNIT_ATTRIBUTE;
            $result[] = AttributeData::AMOUNT_ATTRIBUTE;
        }

        return $result;
    }
}
