<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

use Amasty\PricePerUnit\Model\UnitEntity\Get;
use Amasty\PricePerUnit\Model\UnitEntity\Save;
use Magento\TestFramework\Helper\Bootstrap;

$objectManager = Bootstrap::getObjectManager();

$unitGet = $objectManager->get(Get::class);
$unitSave = $objectManager->get(Save::class);

$unitEntity = $unitGet->execute(0);
$unitEntity->setName('unit');
$unitEntity->setMeasureUnit('Gr');
$unitEntity->setReferenceUnit('Kg');
$unitEntity->setConversionRate(1);
$unitEntity->setReferenceAmount(1000);
$unitEntity->isObjectNew(true);
$unitEntity->setTextTemplate('{{unit_price}} / {{reference_amount}} {{reference_unit}}');

$unitSave->execute($unitEntity);
