<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Price Per Unit by Amasty
 */

namespace Amasty\PricePerUnit\Ui\Component;

use Amasty\PricePerUnit\Controller\Adminhtml\Unit\Delete;
use Magento\Framework\AuthorizationInterface;
use Magento\Framework\View\Element\UiComponent\ContextInterface;

class MassAction extends \Magento\Catalog\Ui\Component\Product\MassAction
{
    /**
     * @var AuthorizationInterface
     */
    private AuthorizationInterface $authorization;

    public function __construct(
        AuthorizationInterface $authorization,
        ContextInterface $context,
        array $components = [],
        array $data = []
    ) {
        $this->authorization = $authorization;
        parent::__construct($authorization, $context, $components, $data);
    }

    public function isActionAllowed($actionType): bool
    {
        $isAllowed = true;
        switch ($actionType) {
            case 'delete':
                $isAllowed = $this->authorization->isAllowed(Delete::ADMIN_RESOURCE);
                break;
            default:
                break;
        }
        return $isAllowed;
    }
}
